VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsINIDatei"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================


' Diese Klasse kapselt die zwei Funktionen leseWert und schreibeWert einer INI-Datei
' Rckgabewert ist bei erfolgreichem Lesen/Schreiben der gelesene/geschriebene Wert
' bei einem Fehler wird "" zurckgegeben


Option Explicit

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

' Liest einen Wert aus dessen Abschnitt und der Variable aus
' Rckgabewert Leerstring, falls ein Fehler auftritt ! + Exception
Public Function leseWert(ByVal sDateiName As String, ByVal sAbschnitt As String, ByVal sVariable As String) As String
    Dim szErgebnis As String                    ' der C-String !
    Dim sErgebnis As String                     ' der umgewandelte VisualBasic-String
    Dim sFehlerText As String                   ' wird zurckgegeben, falls ein Fehler auftritt
    Dim lLaenge As Long
    
    sFehlerText = "*Fehler*"                    ' Defaultwert, wenn ein Fehler aufgetreten ist
    szErgebnis = String(255, Chr$(0))           ' Puffer
    lLaenge = GetPrivateProfileString(sAbschnitt, sVariable, sFehlerText, szErgebnis, 255, sDateiName)
    
    sErgebnis = Left$(szErgebnis, lLaenge)      ' C-String umwandeln
    
    If (sErgebnis = sFehlerText) Then           ' falls ein Fehler aufgetreten ist
        leseWert = ""                           ' wird ein Leerstring zurckgegeben
        Err.Raise vbObjectError + 1, "clsINIDatei", "Fehler beim Lesen aus der ini-Datei"
        'End
    Else
        leseWert = sErgebnis
    End If
End Function

' schreibt einen Wert in eine Variable in einem Abschnitt
' Rckgabewert: Leerstring, falls ein Fehler auftritt, sonst den geschriebenen Wert
Public Function schreibeWert(ByVal sDateiName As String, ByVal sAbschnitt As String, ByVal sVariable As String, sNeuerWert As String) As String
    Dim lLaenge As Long

    lLaenge = WritePrivateProfileString(sAbschnitt, sVariable, sNeuerWert, sDateiName)
    
    If (lLaenge = Len(sNeuerWert)) Then                     ' wenn alles korrekt geschrieben wurde
        schreibeWert = sNeuerWert                           ' dann den geschriebenen Wert zurckgeben
    Else
        schreibeWert = ""                                   ' ansonsten ein Leerstring
'        Err.Raise vbObjectError + 2, "clsINIDatei", "Fehler beim Schreiben in die ini-Datei"
    End If
End Function
