VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPMAusleser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================


' Diese Klasse ffnet die angegebene Draft-Datei und erstellt fr alle gefundenen
' Passmae eine PassMassTabelle

Option Explicit

Const c_sPassMassTabellenGruppenName = "Passma-Tabelle"
Const c_sAlterPassMassTabellenGruppenName = "Pama-Tabelle"

Const c_sAttributSetName = "PROCIM_PM_AttrSet"

Const c_sFormatVorlage = "MR"                       ' Die Standard - Formatvorlage fr die MR - Textboxen

Const c_dBreite = 0.0245
Const c_dHoehe = 0.007

Private dXstartPunkt As Double                      ' Startpunkte der PM-Tabelle 0.05
Private dYstartPunkt As Double                      ' 0.05

Private sFehler As String                           ' Der aktuelle FehlerCode der Klasse
Private lGruppenNummerPassmassTabelle As Long       ' Die Gruppennummer der PassMassTabelle

Private DraftApp As SolidEdgeFramework.Application
Private DraftDoc As SolidEdgeDraft.DraftDocument
Private tzZeilen As clsTabellenZeilen
Private pmTabelle As clsPassMassTabelle

' SolidDraft starten bzw nur einen Verweis anlegen
Private Sub Class_Initialize()
    Set pmTabelle = New clsPassMassTabelle
    If (pmTabelle.Fehler <> "") Then
        sFehler = pmTabelle.Fehler
        Exit Sub
    End If
    On Error Resume Next
    
    Set DraftApp = GetObject(, "SolidEdge.Application") ' Verweis auf SolidDraft
        'DraftApp.Interactive = false                    ' SolidDraft sperren
        If (Err <> 0) Then
            Err.Clear
            sFehler = "SolidDraft ist nicht geffnet !"
        Else
            Set DraftDoc = DraftApp.ActiveDocument      ' Verweis auf Dokument
                If (Err <> 0) Then
                    sFehler = "Kein Dokument offen !"
                End If
                DraftDoc.Activate                       ' Wichtig, da sonst das DraftDoc.ActiveSheet nicht funktioniert
                DraftDoc.SelectSet.RemoveAll            ' falls ein Element selektiert ist, dann Selektion entfernen !!!
        End If
    Set tzZeilen = New clsTabellenZeilen
    dXstartPunkt = -0.005                               'darf nicht 0 sein da sonst die Abfrage des Ursprunges
    dYstartPunkt = -0.005                               'in der StaticVariablen immer auf 0 hngen bleibt
    DoEvents
End Sub

' gibt den aktuellen FehlerCode zurck
Public Function ermittleFehler() As String
    ermittleFehler = sFehler
End Function

' gibt zurck, ob die PassMassTabelle schon existiert !
Private Function existiertPassMassTabelle() As Boolean
    Dim bErgebnis As Boolean
    Dim lGruppe As Long
    
    bErgebnis = False
    lGruppenNummerPassmassTabelle = -1
    
    With DraftDoc.ActiveSheet.Groups                    ' nach den Alten Tabellen suchen
        For lGruppe = 1 To .Count
            If (.Item(lGruppe).UserDefinedName = c_sAlterPassMassTabellenGruppenName) Then
                bErgebnis = True
                lGruppenNummerPassmassTabelle = lGruppe
                Exit For
            End If
        Next lGruppe
    
        If (lGruppenNummerPassmassTabelle = -1) Then                    ' der Name existiert nicht -> Gruppen durchsuchen
            For lGruppe = 1 To .Count
                If (.Item(lGruppe).TextBoxes.Count > 0) Then            ' falls berhaupt Textboxen da sind
                    If (.Item(lGruppe).TextBoxes(1).Text = "Pama") Then
                        '.Item(lGruppe).TextBoxes(1).Text = "Passma") Then ' Diese Gruppe enthlt die Passmatabelle !
                        bErgebnis = True
                        lGruppenNummerPassmassTabelle = lGruppe
                        Exit For
                    End If
                End If
            Next lGruppe
        End If
                                                                        ' falls keine alte Tabelle da ist, dann
        If (lGruppenNummerPassmassTabelle = -1) Then                    ' der Name der neuen Tabelle suchen
            For lGruppe = 1 To .Count
                If (.Item(lGruppe).UserDefinedName = c_sPassMassTabellenGruppenName) Then
                    bErgebnis = True
                    lGruppenNummerPassmassTabelle = lGruppe
                    Exit For
                End If
            Next lGruppe
        End If
    End With
    
    existiertPassMassTabelle = bErgebnis
End Function

' Lscht die PassMassTabelle
Private Sub loeschePassMassTabelle()
    Dim dxmax As Double, dymin As Double                ' Dummy-Variablen !
    
    With DraftDoc.ActiveSheet.Groups.Item(lGruppenNummerPassmassTabelle)
        .Range dXstartPunkt, dymin, dxmax, dYstartPunkt
        .Delete
    End With
  
End Sub

' erstellt eine neue PassMassTabelle (und berschreibt die alte !!!)
Public Sub erstellePassMassTabelle()
    Dim iMsg As Integer
    
    lesePassMasseAus                                ' erst alle auslesen
    If (existierenPassMasse = True) Then            ' falls welche existieren
        'lesePassMasseAus
        If (existiertPassMassTabelle = True) Then
            iMsg = MsgBox("Es existiert schon eine Tabelle! Wollen Sie diese berschreiben ?", vbYesNo + vbInformation, "Hinweis")
            If (iMsg = vbNo) Then                   ' Programm abbrechen
                Exit Sub
            End If
            loeschePassMassTabelle                  ' Tabelle lschen
        End If
        zeichnePassMassTabelle                      ' und neu zeichnen
    Else
        MsgBox "Keine Passmae im Draft vorhanden !", vbOKOnly + vbInformation, "Hinweis"
    End If
End Sub

' zeichnet aus den sortierten Daten der TabellenZeilen eine Passmasstabelle
Private Sub zeichnePassMassTabelle()
    Dim dNennMass As Double, dUnteresGrenzAbmass As Double, dOberesGrenzAbmass As Double
    Dim sToleranz As String
    Dim sUnteresAbmass As String, sOberesAbmass As String
    Dim lGruppenNummer As Long
    Dim sMailText As String, sGesamterMailText As String
    Dim mailNachricht As clsMail
    
    With DraftDoc.ActiveSheet.Groups
        .add c_sPassMassTabellenGruppenName                         ' neue Gruppe hinzufgen
        lGruppenNummer = .Count                                     ' und Nummer merken
    End With

    With DraftDoc.ActiveSheet.Groups(lGruppenNummer)
        .AttributeSets.add c_sAttributSetName
         With .AttributeSets.Item(1)
            .add "AStringAttr", seStringANSI
            .Item(1) = "Pamatabelle"                              ' muss mit  geschrieben sein (wegen SMAP ???)
        End With
    End With
    
    erstelleTextBoxZeile lGruppenNummer, "Pama", "Abmae"        ' NEUE RECHTSCHREIBUNG ??? der Tabellenkopf
    
    Do While (tzZeilen.leseWerte(dNennMass, sToleranz, dUnteresGrenzAbmass, dOberesGrenzAbmass) = True)
        If (dOberesGrenzAbmass = 0 And dUnteresGrenzAbmass = 0) Then    ' Werte noch nicht vorhanden
            
            sMailText = "PassMass " & CStr(dNennMass) & " " & sToleranz & " nicht vorhanden !"
            MsgBox sMailText, vbOKOnly + vbInformation, "Hinweis"
            sGesamterMailText = sGesamterMailText + Chr$(10) + sMailText
                       
        End If
        sUnteresAbmass = CStr(dUnteresGrenzAbmass / 1000)
        erstelleVorzeichen sUnteresAbmass
        sOberesAbmass = CStr(dOberesGrenzAbmass / 1000)
        erstelleVorzeichen sOberesAbmass
        erstelleTextBoxZeile lGruppenNummer, CStr(dNennMass) & " " & sToleranz, sUnteresAbmass, sOberesAbmass
    Loop
    
    If (sGesamterMailText <> "") Then                               ' Hier eine Mail mit sMailText schreiben !
        Set mailNachricht = New clsMail
        mailNachricht.sendeMail pmTabelle.ermittleAdressat, sGesamterMailText, "Passma-Tabelle erweitern"
        Set mailNachricht = Nothing
    End If
    DraftDoc.ActiveSheet.Groups(lGruppenNummer).Select              ' Muss selektiert werden, da man ansonsten die Elemente einzeln anwhlen kann
    DraftApp.ActiveWindow.SelectSet.RemoveAll                       ' Selection wieder aufheben !
End Sub
' erstellt eine neue Textbox und fgt diese der Gruppe hinzu
Private Sub erstelleTextBoxZeile(ByVal lGruppenNummer As Long, ByVal sTextLinks As String, ByVal sTextRechts As String, Optional ByVal sTextRechtsOben As String = "")
    Static dX As Double, dY As Double
    
    
'****************************
'unsaubere Lsung, da Probleme wenn dxStartPunkt = 0 ==> dann bleibt Abfrage immer auf 0 hngen
    
    If (dX = 0) Then                                    ' einmal instanzieren
        dX = dXstartPunkt                               ' linke obere (!!!!) Ecke
        dY = dYstartPunkt '+ c_dHoehe                   '
    Else
        dY = dY - c_dHoehe                              ' ansonsten nchste Zeile anwhlen
    End If
    
    With DraftDoc.ActiveSheet
        .TextBoxes.AddByTwoPoints dX, dY - c_dHoehe, 0, dX + c_dBreite, dY, 0       ' Linke Seite
        formatiereTextbox .TextBoxes.Item(.TextBoxes.Count), sTextLinks, False      ' linke Spalte ("Passmae")
        .TextBoxes.Item(.TextBoxes.Count).Select
        .Groups(lGruppenNummer).AddToGroup
        DraftDoc.SelectSet.RemoveAll
                                                                                    ' Rechte Seite
        If (sTextRechtsOben = "") Then                              ' leer => berschrift => hohe Textbox
            .TextBoxes.AddByTwoPoints dX + c_dBreite, dY - c_dHoehe, 0, dX + 2 * c_dBreite, dY, 0
            formatiereTextbox .TextBoxes.Item(.TextBoxes.Count), sTextRechts, False
            .TextBoxes.Item(.TextBoxes.Count).Select
            .Groups(lGruppenNummer).AddToGroup
            DraftDoc.SelectSet.RemoveAll
            
        Else                                                        ' Mae => oben und unten schmale Textbox
                                                                    ' Dummy-Textbox mit Rahmen
            .TextBoxes.AddByTwoPoints dX + c_dBreite, dY - c_dHoehe, 0, dX + 2 * c_dBreite, dY, 0
            formatiereTextbox .TextBoxes.Item(.TextBoxes.Count), "", False
            .TextBoxes.Item(.TextBoxes.Count).Select
            .Groups(lGruppenNummer).AddToGroup
            DraftDoc.SelectSet.RemoveAll
                                                                    ' die schmalen Boxen dann ohne Rahmen => Schrift ist grer !
            .TextBoxes.AddByTwoPoints dX + c_dBreite, dY - c_dHoehe / 2, 0, dX + 2 * c_dBreite, dY, 0
            formatiereTextbox .TextBoxes.Item(.TextBoxes.Count), sTextRechtsOben, True
            .TextBoxes.Item(.TextBoxes.Count).Select
            .Groups(lGruppenNummer).AddToGroup
            DraftDoc.SelectSet.RemoveAll
        
            .TextBoxes.AddByTwoPoints dX + c_dBreite, dY - c_dHoehe, 0, dX + 2 * c_dBreite, dY - c_dHoehe / 2, 0
            formatiereTextbox .TextBoxes.Item(.TextBoxes.Count), sTextRechts, True
            .TextBoxes.Item(.TextBoxes.Count).Select
            .Groups(lGruppenNummer).AddToGroup
            DraftDoc.SelectSet.RemoveAll
        End If
    End With
End Sub
' Stellt bei einer Textbox den Rahmen ein, Ausrichtung, usw.
Private Sub formatiereTextbox(ByRef tbTextBox As SolidEdgeFrameworkSupport.TextBox, ByVal sText As String, ByVal bKlein As Boolean)
    With tbTextBox
        .Text = sText
        .Edit.Name = c_sFormatVorlage               ' muss gesetzt werden, da bei SIEMENS-Zeichnungen andere Vorlagen
        .Edit.Font = "Arial"
        .Edit.HorizontalAlignment = igTextHzAlignCenter
        If (bKlein = True) Then                     ' Kleine Boxen => kein Rahmen !!!
            .Edit.TextSize = 0.0025                 ' Schriftgre wie bei den alten Tabellen
            .Height = c_dHoehe / 2
        Else                                        ' Groe Boxen mit Rahmen
            .BorderType = igTextBorderRectangle
            .Edit.TextSize = 0.0035
            .Height = c_dHoehe
        End If
        
        .AttributeSets.add c_sAttributSetName       ' neues AttributeSet mit dem entsprechenden Namen
        
        With .AttributeSets.Item(1)
            .add "AStringAttr", seStringANSI
            .Item(1) = "Tabellen-berschrift"
        End With
    End With
End Sub
' startet das Auslesen der Passmae (oberste Ebene + Gruppen)
Private Sub lesePassMasseAus()
    Dim lGruppe As Long                                             ' Zhlervariable
    
    With DraftDoc.ActiveSheet
        lesePassMassAus .Dimensions                                 ' Die "normalen" Symbole
        
        For lGruppe = 1 To .Groups.Count                            ' Die Gruppen
            lesePassMassAus .Groups.Item(lGruppe).Dimensions
        Next lGruppe
    End With
    
End Sub
' liest die Passmae aus dem Draft aus und fgt sie in die Unterklasse clsTabellenZeilen ein
Private Sub lesePassMassAus(ByVal dimDimensions As SolidEdgeFrameworkSupport.Dimensions)
    Dim sToleranz As String
    Dim dNennMass As Double
    Dim dUnteresGrenzAbmass As Double, dOberesGrenzAbmass As Double
    Dim lElement As Long                                                ' Zhlervariable
    
    With dimDimensions
        For lElement = 1 To .Count
            If (.Item(lElement).DisplayType = igDimDisplayTypeClassfit) Then ' nur die !!!!!
                sToleranz = .Item(lElement).PrimaryToleranceSymbol
                 
                If (sToleranz <> "") Then                               ' Passma gefunden !
                    dNennMass = Round(.Item(lElement).Value * 1000, 2)
                    pmTabelle.lese dNennMass, sToleranz, dUnteresGrenzAbmass, dOberesGrenzAbmass
                    tzZeilen.add dNennMass, sToleranz, dUnteresGrenzAbmass, dOberesGrenzAbmass
                End If
            End If
        Next lElement
    End With
    
End Sub

' berprft, ob berhaupt Passmae ausgelesen wurden
Private Function existierenPassMasse() As Boolean
    If (tzZeilen.existierenWerte = True) Then
        existierenPassMasse = True
    Else
        existierenPassMasse = False
    End If
End Function
' Fgt dem String bei Bedarf ein "+" hinzu !
Private Sub erstelleVorzeichen(ByRef sZahl As String)
    If (Left$(sZahl, 1) <> "-" And Left$(sZahl, 1) <> "+") Then
        If (sZahl <> "0") Then              ' +0 sieht komisch aus !
            sZahl = "+" + sZahl
        End If
    End If
End Sub
' Dokument und Applikation wieder freigeben
Private Sub Class_Terminate()
    Set tzZeilen = Nothing
    Set pmTabelle = Nothing
    Set DraftDoc = Nothing
        DraftApp.Interactive = True
    Set DraftApp = Nothing
End Sub

