VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPassMassTabelle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Kapselt die Excel-Passmatabelle"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================


' Diese Klasse kapselt die Exceltabelle
' H6 => H = Toleranzfeld (Achtung Unterschied zwischen Gro- und Kleinbuchstaben !)
'       h = Kleinbuchstabe ! (In der Excel-Tabelle "H_")
'       6 = Toleranzgrad
' Zu jedem Wert gibt es ein oberes Grenzabmass und
'                       ein unteres Grenzabmass

'Const constExcelTabellenName = "PassMassTabelle.xls"
'Const constExcelTabellenPfad = "\\Solidserv\Daten\Datenbank\"
'"\\Solidserv\Daten\Admin\Programme\src\KlassenSammlung\PassMassTabelle\"
                              
Private sFehler As String                                               ' ein Fehler ist aufgetreten !
Private sToleranzFeld As String
Private lToleranzGrad As Long
Private ExcelApp As Excel.Application
Private bExcelSchonGeoeffnet As Boolean                                 ' war Excel vorher schon geffnet ?
Private bPassMassTabelleSchonGeoeffnet As Boolean                       ' war die Tabelle schon geffnet ?

Option Explicit

' Konstruktor: Excel-Sheet ffnen
Private Sub Class_Initialize()
    Dim lElement As Long
    Dim sEXCELDateiName As String                                            ' Name der ExcelTabelle
    Dim iniDatei As clsINIDatei
    Dim fsDatei As clsFileString
    
    Set iniDatei = New clsINIDatei
        With iniDatei
            sEXCELDateiName = .leseWert(App.Path & "\" & App.EXEName & ".ini", "Optionen", "PassMassDatei")
        End With
    Set iniDatei = Nothing
    
    On Error Resume Next
    
    Set ExcelApp = GetObject(, "Excel.Application")                     ' Excel schon aktiv ?
    If (Err.Number <> 0) Then
        If (Err.Number = 429) Then
            Err.Clear
            Set ExcelApp = CreateObject("Excel.Application")            ' nein => Excel starten
        Else                                                            ' unbekannter Fehler !
            Err.Clear
            sFehler = "Kann aktives Excel nicht ansteuern. Fehler Nr. = " & Err & "."
            Exit Sub
        End If
        bExcelSchonGeoeffnet = False                                    ' fr spter merken !
    Else
        Err.Clear
        bExcelSchonGeoeffnet = True                                     '
    End If
           
    bPassMassTabelleSchonGeoeffnet = False
    
    Set fsDatei = New clsFileString
        With ExcelApp
            For lElement = 1 To .Workbooks.Count                                   ' alle Arbeitsmappen durchsuchen
                If (fsDatei.convertNachUNC(.Workbooks(lElement).FullName) = sEXCELDateiName) Then       ' Datei schon geffnet !
                    .Workbooks(lElement).Activate                                  ' dann aktivieren
                    bPassMassTabelleSchonGeoeffnet = True
                    Exit For
                End If
            Next lElement
        End With
    Set fsDatei = Nothing
            
    If (bPassMassTabelleSchonGeoeffnet = False) Then                    ' Datei noch nicht geffnet => ffnen
        'sDateiName = constExcelTabellenPfad & constExcelTabellenName
        
        ExcelApp.Workbooks.Open sEXCELDateiName                              ' Arbeitsmappe ffnen
        If (Err = 1004) Then                                            ' Kann Datei nicht ffnen
            sFehler = "Datei " & sEXCELDateiName & " nicht gefunden ! Fehler Nr. = " & Err & "."
        End If
    End If
End Sub
' Destruktor: Excel Sheet schlieen
Private Sub Class_Terminate()
    If (bPassMassTabelleSchonGeoeffnet = False And Err <> 1004) Then                   ' Falls Tabelle von der Klasse geffnet wurde
        ExcelApp.ActiveWorkbook.Close True                              '     => Schlieen und speichern
    End If
    
    If (bExcelSchonGeoeffnet = False) Then                              ' Falls Excel von der Klasse geffnet wurde
        ExcelApp.Quit
    End If
     
    Set ExcelApp = Nothing
End Sub
' Liefert den aktuellen Fehler zurck
Public Function Fehler() As String
    Fehler = sFehler
End Function

' Liest Daten aus der Passmasstabelle aus; sToleranz beinhaltet Toleranzfeld + Toleranzgrad z.B. "H6"
Public Sub lese(ByVal dNennMass As Double, ByVal sToleranz As String, ByRef dUnteresGrenzAbmass As Double, ByRef dOberesGrenzAbmass As Double)
    'If (sFehler <> "") Then Exit Sub
  
    Dim lZeile As Long, lSpalte As Long
    
    If (spalteToleranzAuf(sToleranz) = False) Then Exit Sub       ' Fehler aufgetreten !
    berechneZeileUndSpalte dNennMass, lZeile, lSpalte
    
    With ExcelApp.Sheets(sToleranzFeld)
        dOberesGrenzAbmass = .Cells(lZeile, lSpalte)
        dUnteresGrenzAbmass = .Cells(lZeile, lSpalte - 1)
    End With
End Sub

' Schreibt Daten in die Excel-Tabelle;  sToleranz wie bei lesen(...)
Public Sub schreibe(ByVal dNennMass As Double, ByVal sToleranz As String, ByVal dUnteresGrenzAbmass As Double, ByVal dOberesGrenzAbmass As Double)
    'If (sFehler <> "") Then Exit Sub
    
    Dim lZeile As Long, lSpalte As Long
    
    If (spalteToleranzAuf(sToleranz) = False) Then Exit Sub       ' Fehler aufgetreten !
    
    If (dUnteresGrenzAbmass = 0 And dOberesGrenzAbmass = 0) Then     ' nur 0 in den H-Tabellen !
        sFehler = "Beide GrenzAbmasse sind 0!"
        Exit Sub
    End If
    
    berechneZeileUndSpalte dNennMass, lZeile, lSpalte
    
    With ExcelApp.Sheets(sToleranzFeld)
        .Cells(lZeile, lSpalte) = dOberesGrenzAbmass
        .Cells(lZeile, lSpalte - 1) = dUnteresGrenzAbmass
    End With
   
End Sub

' Markiert die Daten der Excel-Tabelle mit Roter Farbe !
Public Sub markiere(ByVal dNennMass As Double, ByVal sToleranz As String)
    'If (sFehler <> "") Then Exit Sub
    
    Dim lZeile As Long, lSpalte As Long
    Dim bOK As Boolean
    
    If (spalteToleranzAuf(sToleranz) = False) Then Exit Sub       ' Fehler aufgetreten
    berechneZeileUndSpalte dNennMass, lZeile, lSpalte
    
    With ExcelApp.Sheets(sToleranzFeld)
        .Cells(lZeile, lSpalte).Interior.ColorIndex = 4
        .Cells(lZeile, lSpalte - 1).Interior.ColorIndex = 4
    End With

End Sub
' Errechnet aus dem Nennma und dem Toleranzgrad die Zeile und die Spalte im Excel-Sheet
Private Sub berechneZeileUndSpalte(ByVal dNennMass As Double, ByRef lZeile As Long, ByRef lSpalte As Long)
    Dim lAktuelleZeile As Long
    
    lSpalte = 2 + (lToleranzGrad * 2)                               ' aus der Excel-Tabelle auslesen
    lZeile = 100                                                     ' falls sonst nichts passt
        
    For lAktuelleZeile = 5 To 100                                    ' Nennmae durchsuchen
        If (Val(ExcelApp.Sheets(sToleranzFeld).Cells(lAktuelleZeile, 1)) >= dNennMass) Then
            lZeile = lAktuelleZeile - 1
            Exit For                                                ' NennMa passt
        End If
    Next lAktuelleZeile

End Sub

' Spaltet den String "H6" in die einzelnen Komponenten auf. Unterscheidet Gross- und Kleinbuchstaben !
' Falls eine entsprechende Tabelle nicht existiert, wird False zurckgegeben
Private Function spalteToleranzAuf(ByVal sToleranz As String) As Boolean
    Dim lPosition As Long
    Dim sToleranzGrad As String
    
    sFehler = ""                                                        ' Fehler zurcksetzen
    
    sToleranz = Trim$(sToleranz)                                        ' Leerzeichen entfernen
    
    lPosition = InStr(sToleranz, " ")                                   ' Leerzeichen herausfiltern
    Do Until (lPosition = 0)
        sToleranz = Left$(sToleranz, lPosition - 1) & Right$(sToleranz, Len(sToleranz) - lPosition)
        lPosition = InStr(sToleranz, " ")
    Loop
    
    ' ToleranzGrad "34"
    
    Select Case Len(sToleranz)
        Case 2                                          ' "C9"
            sToleranzGrad = Right$(sToleranz, 1)
        Case 3                                          ' "JS4" bzw "A12"
            If (UCase$(Left$(sToleranz, 2)) = "JS") Then     ' - "JS4"
                sToleranzGrad = Right$(sToleranz, 1)
            Else                                        ' - "A12"
                sToleranzGrad = Right$(sToleranz, 2)
            End If
        Case 4                                          ' "JS34"
            sToleranzGrad = Right$(sToleranz, 2)
    End Select
  
    ' ToleranzFeld "H6"
    If (UCase$(Left$(sToleranz, 2)) = "JS") Then                        ' bei js und JS die ersten 2 Buchstaben
        sToleranzFeld = Left$(sToleranz, 2)
    Else
        sToleranzFeld = Left$(sToleranz, 1)                             ' ganz links genau 1 Buchstabe
    End If
    
    If (sToleranzFeld >= "a" And sToleranzFeld <= "z") Then             ' Kleinbuchstabe
        sToleranzFeld = sToleranzFeld + "_"                             '    => "_" vorne dranstellen
    ElseIf (sToleranzFeld >= "A" And sToleranzFeld <= "Z") Then
        ' ok
    Else
        sFehler = "Ungltige ToleranzTabelle: " & sToleranzFeld & "."
        spalteToleranzAuf = False                                      ' Ungltige Tabelle
        Exit Function
    End If
      
    On Error Resume Next
    lToleranzGrad = CInt(sToleranzGrad)                   ' dann rechts 1 oder 2 Zahlen
    
    If (Err <> 0 Or lToleranzGrad = 0) Then               ' Fehler beim Umwandeln in Zahlen !
        Err.Clear
        sFehler = "ToleranzGrad " & lToleranzGrad & " ist keine Zahl."
        spalteToleranzAuf = False
        Exit Function
    End If
    
    If (lToleranzGrad < 1 Or lToleranzGrad > 18) Then                   ' ToleranzGrad muss zwischen 1 und 18 liegen !
        sFehler = "Toleranzgrad " & lToleranzGrad & " ist nicht zwischen 1 und 18."
        spalteToleranzAuf = False
        Exit Function
    End If
    
    spalteToleranzAuf = True
End Function
' liefert aus der Tabelle "Info" den Adressaten
Public Function ermittleAdressat() As String
    ermittleAdressat = ExcelApp.Sheets("Info").Cells(4, 2).Value
End Function
